%%%%%%%%%%%%%%  LP shortest path search for Assignment 3 %%%%%%%%%%%%%%%%%%%%%
clear all;
format compact;
more on;

% Data for Washington Map

% Numbering of cities - latitudes and longitudes
% 1. 48.80  122.53  Bellingham,WA
% 2. 47.48  122.77  Bremerton,WA
% 3. 47.32  119.52  Ephrata,WA
% 4. 47.92  122.28  Everet,WA
% 5. 47.20  119.32  Moses Lake,WA
% 6. 46.97  122.90  Olympia,WA
% 7. 46.27  119.12  Pasco,WA
% 8. 48.12  123.50  Port Angeles,WA
% 9. 46.75  117.12  Pullman,WA
% 10. 47.50  122.22  Renton,WA
% 11. 47.45  122.30  Seattle,WA
% 12. 47.25  123.15  Shelton,WA
% 13. 47.63  117.53  Spokane,WA
% 14. 47.27  122.58  Tacoma,WA
% 15. 46.10  118.28  Walla Walla,WA
% 16. 47.40  120.20  Wenatchee,WA
% 17. 46.57  120.53  Yakima,WA

% Numbering of paths
% 1.	Bellingham - Everett 62
% 2.	Everett - Wenatchee 122
% 3.	Everett - Seattle 29
% 4.	Everett - Renton 39
% 5.	Seattle - Renton 12
% 6.	Seattle - Bremerton 34
% 7.	Bremerton - Port Angeles 76
% 8.	Bremerton - Tacoma 34
% 9.	Port Angeles - Shelton 99
% 10.	Shelton - Olympia 22
% 11.	Tacoma - Olympia 31
% 12.	Tacoma - Renton 27
% 13.	Seattle - Tacoma 34
% 14.	Olympia - Yakima 177
% 15.	Renton - Yakima 142
% 16.	Wenatchee - Yakima 106
% 17.	Yakima - Ephrata 94
% 18.	Wenatchee - Ephrata 49
% 19.	Ephrata - Moses Lake 19
% 20.	Yakima - Moses Lake 100
% 21.	Yakima - Pasco 86
% 22.	Pasco - Walla 48
% 23.	Moses Lake - Pasco 72
% 24.	Walla Walla - Pullman 115
% 25.	Moses Lake - Spokane 105
% 26.	Spokane - Pullman 76

% Set up incidence matrix
A=zeros(17,26);
A(1,1)=1; A(4,1)=-1;
A(4,2)=1; A(16,2)=-1;
A(4,3)=1; A(11,3)=-1;
A(4,4)=1; A(10,4)=-1; 
A(11,5)=1; A(10,5)=-1;
A(11,6)=1; A(2,6)=-1; 
A(2,7)=1; A(8,7)=-1;
A(2,8)=1; A(14,8)=-1;
A(8,9)=1; A(12,9)=-1;
A(12,10)=1; A(6,10)=-1;
A(14,11)=1; A(6,11)=-1;
A(14,12)=1; A(10,12)=-1;
A(11,13)=1; A(14,13)=-1;
A(17,14)=1; A(6,14)=-1;
A(10,15)=1; A(17,15)=-1;
A(16,16)=1; A(17,16)=-1;
A(17,17)=1; A(3,17)=-1;
A(16,18)=1; A(3,18)=-1;
A(3,19)=1; A(5,19)=-1;
A(17,20)=1; A(5,20)=-1;
A(17,21)=1; A(7,21)=-1;
A(7,22)=1; A(15,22)=-1;
A(5,23)=1; A(7,23)=-1;
A(15,24)=1; A(9,24)=-1;
A(5,25)=1; A(13,25)=-1;
A(13,26)=1; A(9,26)=-1;

% Set up costs
%			   1   2   3   4  5  6  7   8  9 10 11  12
distances = [ 62 122  29  39 12 34 76  34 99 22 31  27 ...
	  		  34 177 142 106 94 49 19 100 86 48 72 115 ...
		     105  76]';
%			  25  26    
% Constraints
b=zeros(17,1); b(6)=1; b(9)=-1;

% Now repeat allowing both directions, taking absolute value for paths (Note: this doesn't really show much
%    because I defined the "right" directions in the first place but if one starts from say Olympia than
%    it does make a difference)
distances=[distances; distances];
A=[A'; -A']';
path=linprog(distances,[],[],A,b,zeros(52,1),ones(52,1));
path'
% Path links traversed
fprintf('Paths traversed are: \n');
for i=1:52 
    if path(i)>0.1, fprintf('%d - ',i); end;
end; 
fprintf('\n');
% Shortest distance
cost1a=distances'*path

% Also show A* algorithm
% Data for Map of France first
tol=0.001;
% Latitudes
lat(1)=-170;lat(2)=-40;lat(3)=160;lat(4)=180;
lat(5)=-60;lat(6)=230;lat(7)=120;lat(8)=140;
lat(9)=360;lat(10)=620;lat(11)=770;lat(12)=510;
lat(13)=480;lat(14)=570;lat(15)=480;
% Path distances
paths(1:15,1:15)=0;
paths(1,2)=176;paths(1,3)=107;paths(1,6)=348;
paths(2,4)=120;paths(2,6)=242;
paths(3,5)=329;paths(3,7)=329;
paths(4,6)=297;paths(4,10)=534;
paths(5,7)=220;paths(5,8)=253;
paths(6,7)=396;paths(6,10)=372;paths(6,12)=313;
paths(7,8)=313;paths(7,13)=389;
paths(8,9)=240;
paths(9,15)=121;
paths(10,11)=145;paths(10,12)=201;
paths(11,12)=335;
paths(12,13)=172;
paths(13,14)=104; paths(13,15)=216;
paths(14,15)=227;
paths=paths+paths';
for i=1:15
   for j=1:15
      if(j~=i & paths(i,j)<tol)
         paths(i,j)=inf;
      end
   end
end
disp(' ');
disp('The A* solution to the path problem');
disp('The shortest path from Rennes to Avignon is');
Astar(paths,lat,15)

disp(' ');
disp('The Dikstra solution to the path problem');
disp('The shortest path from Rennes to Avignon is');
Astar(paths,0*lat,15)

% Now for WA 
% Need to do some switching to use the Astar algorithm as 
% written. Start must be 1 and end must be highest numbered 
% node. Renumber Olympia as 1 (Bellingham 6) and Pullman as 
% 17 (Yakima 9).
paths(1:17,1:17)=0;
paths(6,4)=62;      paths(4,16)=122;
paths(4,11)=29;     paths(4,10)=29; 
paths(10,11)=12;    paths(2,11)=34; 
paths(2,8)=76;      paths(2,14)=34;
paths(8,12)=99;     paths(1,12)=22;
paths(1,14)=31;     paths(10,14)=27;
paths(11,14)=34;    paths(1,9)=177;
paths(10,9)=142;   paths(16,9)=106;
paths(3,9)=94;     paths(3,16)=49;
paths(3,5)=19;      paths(5,9)=100;
paths(7,9)=86;     paths(7,15)=48;
paths(5,7)=72;      paths(17,15)=115;
paths(5,13)=105;    paths(17,13)=76;
paths=paths+paths';
for i=1:17
   for j=1:17
      if(j~=i & paths(i,j)<tol)
         paths(i,j)=inf;
      end
   end
end
% First longitudes
long=[122.53  122.77  119.52  122.28  119.32  ...
      122.90  119.12  123.50  117.12  122.22  ...
      122.30  123.15  117.53  122.58  118.28  ...
      120.20  120.53];
% Again to do some switching to use the Astar algorithm as 
% written. 
long=[long(6) long(2:5) long(1) long(6:8) long(17) ...
      long(10:16) long(9)];
% Now latitudes
lat=[48.80 47.48 47.32 47.92 47.20 46.97 46.27 ... 
        48.12 6.75  47.50 47.45 47.25 47.63 47.27 ...
        46.10 47.40 46.57 ];
% Again to do some switching to use the Astar algorithm as 
% written. 
lat=[lat(6) lat(2:5) lat(1) lat(6:8) lat(17) ...
      lat(10:16) lat(9)];

disp(' ');
disp('The A* solution to the path problem');
disp('The shortest path from Olympia to Pullman is');
% Used a simple heuristic of 200 latitude difference is an estimate to goal
Astar(paths,200*lat,17);
% In this output
disp('Here 1-9-7-15-17 is Oly-Yakima-Pasco-Walla-Pullman');

% We can get the same result with Dijkstra. 
disp(' ');
disp('The Dijkstra solution to the path problem');
disp('The shortest path from Olympia to Pullman is');
Astar(paths,0*(lat+long),17);

return

